//	DOB_FinancialReportWorksheet(v7.0).pas
//	(actual file name varies by installation)
//		July 28, 2010	PMatjea
//		Version 2.0

// Version release notes:
	// 	new versions must replace all files, including the COA Group.
		// Change the program name variable in this program: search for wxPgmVer
		// Change the COA Group name variable in this program to match the actual coa group file name, search for wxCoaGroupName

// Revised: 7/202020  RDychowski
	// Version 7.0
	// Revised Group List

// Revised: 2/28/2019  RDychowski
	// Version 6.0
	// Revised Group List

// Revised: 6/27/2018  RDychowski
	// Version 5.0
	// Revised Group List

// Revised: 6/17/2016  PMateja
	// Version 4.0
	// Revised Group List
	

// Revisions:
	//	5/27/2014  PMateja
		// Version 3.0
		//	Added Next Fiscal Year Annual Budget field to report
		//	Added section number to Main Report Table to allow testing of sections to control printing of headings
		//	Changed report layout, allow more spaces between column such that export to Excel formats better
		//	Changed the Group Report version to match this program version, although no changes were made to the group report
		// 	Save/Read parish number, name, city, yourname in the report ini file
		//	Things left to do:
			//	use relative spacing for number columns so that report will print reasonibly well in portrait
					// not be possible
			//	test surplus/deficit totaling
			//	test abnormal balances
			//	Done. get budgets on recap page
			//	Done. change version id wxPgmVer
			//	done. test other as of dates. seems to work as expected.
			//	done. Print different headings when printing error and recap sections, use embedded code
			//	done. Change group version# to match 
			//	done. save/retrieve parish name, city info to ini file			
			
			
	// 04/27/12  PMateja
		// Changed version to 2.0 from 1.0 beta
		//	 Change reference to group list version 2.0
	// 10/2/10	PMateja
		//	Removed Section II - Diocesan Exclusions; only the code for the screen has been commented out, 
				// other areas are left in for possible future use
		//	Change the report output to use the word Part instead of Section; however, this program still uses the word Section, 
			//	thus, the two words may be used interchangeably in this program
		
// Things to do in this program:
//	- Need better test data so that every account has some amount in it
//	- Add Error checking for screen: test group and user name 
// Move the total field more to the right on each subsequent total, such that when two totals print one after another, the second total
	// will be indented more to the right.

// Important Notes: 
//	1. additional coding exist in the Report Writer Embedded Code.  Printing attributes, such as bold, page breaks were done within the 
//	report writer.  Embedded coding has been placed in the following areas:
//		"do before" print routine for the detail band of the main and sub reports
//		various "Label" fields of the main and sub reports: get text and do before print routines
//		A Group is defined to provide page breaks based on the Page/Section field (K1) in the wxRptTbl table

//	2. This program monitors for certain Group Specs which are used in the following manner:
	//	"Print a new heading account" (value = 3)may be used to indicate the account types and/or the section being processed:
		// the section is indicated in the alternate account number
			// Alternate accounts for Headings:
			//	III.2	Start of School
			//	III.1	Start of Parish
			//	III.3	Start of Cemetery
	//	"Print a new total account"	(value = 5) may be used used to capture totals for later printing in the recap section
		// the alternate account number is indicated when a total is to be captured.  The alternate number may be any number, 
		//	even if it is a number used in the diocesan report.  This is because the total alternate number is maintained in a 
		//	separate table.  Only when the entire chart is processed are these total alternate numbers used.  therefore there is no chance
		//	of the diocesan numbers and the total alternate nubmers interferring with one another.
			// Alternate accounts for Totals:
			//	199.x 	Total Assets, where x is the department: 1=parish, 2=school, 3=cemetery
			//	299.x	Total Liabilities
			//	399.x	Total Recepts
			//	499.x	Total Expenses
	// other values are:
		// 6 = net, 7 = blank, 13 = detail

//	3. The basic logic structure of this program is:
	//	Load the chart of accounts into a table (only detail, master and sub accounts are processed)
	//	Process the group list specs
		//	monitor for account types, sections, and totals: process accordingly
		//	after all group specs are processed for the Annual Report then all valid COA have been processed, those that remain are errors
			//	Process section I - Errors (procedure sxSectionI)
					// once this section is process then the entire COA has been processed, the chart table is now empty
			//	Write the captured totals to the chart table
			//	Process Recap Section; this section list alternate account numbers of the totals captured earlier.
	//	Done.


// Completed items:
//	- Ensure that tables are initialized when "back" button is pressed after preview
//	- Change report type to a COA report
//	- Add screen to capture group report name and month/year. But, a this point not sure how to work with month/year.
//	- Specify a date in the format month/year
//	- Using the specifed date (in month/year format) obtain appropriate balance
//	- Work on a TotalLevel Table or something akin and the section of the code for adding balances tot the Total Level Table and Print Total Account
//	- High Priority: problem when using Report Writer, program defaults to first Group, causes excess processing and Ledger freezes
	//	Fix: if no report indicate, force group spec 
	//	- Have group drop default to DOB_AnnualFinancialReport
//	- Add Account Status to report
//	- subreports
//	- newpage field from the DM group spec table (the field name may be called blankpage)
//	- break to a new page for the worksheet vs the exceptions
	//	Used the Section/Page Print Sequence field to do the page breaks in conjunction with the report writer.  As it currently stands, there are 
	//	three values defined for Print Sequence: 1 = errors, 2 = Ignores, and 3 = Report.  Further define the "Report" value, by incrementing beyond 
	//	3 when a page break is needed.  That will still keep everything together for each major section.  Thus, when
	//	processing the group records, if the newpage field is set to true then increment the Section/Page Sequence.  Within the report writer, set the Group
	//	page break field to the Print Sequence.  The value of 1 and 2 will still be used as it is currently defined and will have the added benefit of 
	//	breaking to a new page when between those sections.
//	- Add back in error testing and printing	
//	- Add Parish name to report heading
//	- Change the nature of "Ignore" section.  It will be called Diocesan Exclusions, the accounts will be part of the group list.
		// This section then, will no longer allow a parish to "ignore/exclude" accounts; account 999.9 is therefore no longer tested.
//	- Add to Screen: display parish name, ask for city and parish number
//	- Rename the report.
//	- Account Balances are all "positive" amounts (unless an abnormal balance); need to flip the sign for all "credit" balance account types; this is
	// required because an alternate account number may be assigned to two different account types (e.g., income and expense).
//	- Add a screen field to print only the "errors and exclusions" pages
	// How will the program know when to stop processing other records.  may need to insert one record in the group that the program will monitor
//	- Test how sub accounts work
	// Found that Master Accounts are considered 'detail' accounts even though they cannot be posted to; therefore, excluded Master accounts.
//	- Add Print Net Account routine
//	- Consider a Recap page:
	//	Capture Total Assets, Liabilities, Receipts, and Expenditures for School, Parish, Cemetery
	//	- Enhance total level routine sxUpdateTLevel
		// consider a way to save and print certain totals, such as, total receipts or total exdenditures; may be able to use 997.x for this
		// Alternate accounts for Totals:
//			199.x 	Total Assets, where x is the department: 1=parish, 2=school, 3=cemetery
//			299.x	Total Liabilities
//			399.x	Total Recepts
//			499.x	Total Expenses
//	- Enhance screen and script as follows:
//		Repot Options:
//			Print the following sections:
//				Section   I - Errors
//				Section  II - Diocesan Exclusions
//				Section III - Annual Report:
//					School
//					Parish
//					Cemetery
//				Section IV - Recap/Summary 
//				Exclude Sub-Totals

// Dismiss items; those item that were once on the things to do list, but for one reason or another was decided to not develop.
//	- Save the screen values to an ini file (may be a way to set the default group name);	see page 91 in adobe file

Uses
scrnio;

var
	wxPgmVer:		string;		// program version name: displayed and printed; the value is set in the AfterLoadReport procedure; 
	
	// Main Report Detail Line; one record in this table is related to one or more records on the sub-report table
	wxRptTbl:	TKbmMemTable;
	wxRptDS:		TDataSource;
	wxRptPL:		TppDBPipeline;

	// Sub-Report Detail Line; one or more record in this table is related to one (and only one) record in the Main Report table
			// important note: there has to be at least one record in the sub table for each record in the main table, otherwise the 
			// record in the main table will not print; not sure why this is but have to deal with it.  Because of this, could not use
			//  the alternate account number as the "join" field between the two tables, as there may be alt# in the group report that 
			//   are not in the chart.  Therefore, had to use internally assigned key fields to group the records together.
	wxSubTbl:		TKbmMemTable;
	wxSubDS:			TDataSource;
	wxSubPL:			TppDBPipeline;

	// Chart of Accounts Table: a copy of the current chart, but only of detail accounts, that is, accounts that can be posted to
	wxCoaTbl:		TKbmMemTable;
	
	//	Total Level Table: accumulates totals based on total levels
	wxTLevelTbl:		TKbmMemTable;
	
	//	Save Total Table: Saves various balance sheet and income statment totals; "when a "print a new total account" contains an alternate number
		// then the Alt# and its total is written to this table.  After Section III - annual report (and sections I and II) are processed and 
		// printed, then the contents of this table is written to the wxCoaTbl table to be processed by Section IV - Recap. 
		// With this technique the group list can be easily changed to capture other totals for the recap without changing this program.
	wxSaveTotalTbl:		TKbmMemTable;

	// Screen Fields:
	wxCoaGroupName: 		TComboBox;
	wxYourName:				string;			// User specified, full name
	wxEndAsOfDate:	  		TDBShortDate;	// the user may set this to any month/year, but it should be a fiscal year end month/year

	// other variables:
    wxStartAsOfDate:		TDBShortDate;	// This field is not set by the user, its value is the same as wxFiscalMonthStateDate
	wxFiscalMonthStartDate:	TDBShortDate;	// This field is not set by the user; its value is the start of the fiscal year relative to the wxEndAsOfDate field
    wxDateLabel: 			TLabel;
	m1, m2, y1, y2:		integer;	// month and year of the short date
	wxUserName:			string;			// the internal Ledger User Name
	wxChurchName: 		string;		// the name of the licensee from the license screen
	wxCityName:			string;		// user entered city name
	wxChurchNumber:		string;		// user entered 4-digit parish number
	wxSection1:			TCheckBox;	// Print Section I - Errors
	wxSection2:			TCheckBox;	// Print Section II - Exclusions
//	wxSection3:			TCheckBox;	// Print Section III - Annual Report
	wxSection31:		TCheckBox;	// Print Section III.1 - Parish Annual Report
	wxSection32:		TCheckBox;	// Print Section III.2 - School Annual Report
	wxSection33:		TCheckBox;	// Print Section III.3 - Cemetery Annual Report
	wxSection4:			TCheckBox;	// Print Section IV - Recap
	wxExcludeSubRpt:	TCheckBox;	// Will not print the sub report, this will print a report very similar to the diocesan report
	
	wxSectionState:		boolean;		// Many times a test is done to determine if a section has started and then do something special, 
											// but once stated it is not necessary to do that something special again, until the section changes.
											// This field is set to true when the section changes.  When something needs to be done once when the 
											// section changes this field is then set to false to let the program know it is done already.
	wxSectionNumber:	integer;		// the integer value of the alternate account number string contained in some Print a Heading group specs
										// It is used to indicate the start of a new section.
											//	'00I' - Errors, = 1
											//	'0II' - Exclusions, = 2
											//	'III.1' - Annual Report, Parish = 31
											//	'III.2' - Annual Report, School = 32
											//	'III.3' - Annual Report, Cemetery = 33
											//	'0IV' - Recap = 4

	// ****************************
		// the following two fields are used to determine what type of accounts are being processed. 
		// Certain group heading records use the Account Type Value field to indicate the account type being processing:	Assets, Liabilities, Receipts, Expenses.
		//	This is required to determine the proper sign of the amounts, how to accumulate for the totals, and computing the net surplus/deficit.
		//	It is also used in the sxUpdateTotalTbl and the sxWriteTlToCoa routines to determine the proper COA values
		
	wxIsDebit:			boolean;	// True if debit, false if credit
			//	Based on this the normal balance can be determined.  If an account from the chart is not of the same balance type (e.g, the group is 
			//	processing debit normal accounts, but a credit normal account is read) then its sign must be reversed.
			
	wxTypeVal:			integer;	// the account type value; 11 = assets, 21 = liabilities, 31 = revenue, 41 = expense
	
	// ****************************

	wxNet:				currency;	// net surplus/deficit
										// considerations for net. Ledger treats all account balances as positive numbers; past experience
										// with other GL systems, debits are positive, credits are negative, thus it is easy to obtain a net by
										// accumulating the account balances.  However, with Ledger it will be necessary to test the report type:
										//	balance sheet or income statement and the account type: asset vs liability or revenue vs expense to 
										//	determine whether to add or subtract and account balance.
										//  Also, with respects to this program and the worksheet, only one field (wxNet) will be used to accumulate 
										//	and print the net balance.  Thus at any give point the net balance may be for balance sheet or income statement
										//	accounts.  This should not be a problem for this program because at no time are the differet report type accounts
										//	comingled (for example, assets with revenuse.  After the amount is printed it will be reset to zero so it will start
										//	accumulating again for the next set of report type accounts. And, indeed it must be printed so this program will
										//	reset it.  If not then the accumulated balance will not be correct if the next set of accounts are of a different
										//	report type.  See also the next field wxSumOfNets.
	wxSumOfNets:		currency;		//	Sum of all nets.  Same issues apply for this field as it does for the field wxNet.  This field will
										//	be reset to zero after it is printed; this is important to be able to produce an accurate sum of the nets.  
										//	Therefore, it is not possible to do balance sheet accounts for school, followed by income statement 
										//	accounts for school, then followed by balance sheet for parish, followed by income statement for parish; then
										//	print the sum of the nets.  The resulting balance will be very strange as the reports types are comingled.  
										//	yet, it is possible to do, as an example: income statement accounts for school, followed by parish, followed by 
										//	cemetery then print a sub of the nets.  Or, another example, Parish Revenue - Parish Operating Expensed =
										//	net operating surplus/deficit - Parish Capital Expenditures = net capital expeditures = Total Surplus/Deficit.
										
// revised: 5/27/2014:
	wxAltBalTotal:			currency;		// total balance for a group of accounts with the same alternate account#; set by the sxGetBalances function
	wxBudYr2Total:			currency;		// total budget  for a group of accounts with the same alternate account#; set by the sxGetBalances function
	
	wxNetBudgetYr2:			currency;		// net budget surplus/deficit (see notes for wxNet and wxSumOfNets; considerations apply as well)
	wxSONBudgetYr2:			currency;		// (same as wxSumOfNets but for budget
	
	wxIniFieldsRead:		boolean;		// used to test when to read/write screen fields to the ini file

// end revised 5/27/2014

	
// ************************************************************************
// ************************************************************************
procedure AddShortDate(s: string; var L: TLabel; var E: TDBShortDate);
  var
    w:  integer;
  begin
    // Add an edit field
    L:=TLabel.Create(CurForm);
    with L do
      begin
        ShowAccelChar:=false;
        Caption:=s;
        Left:=LabelL;
        Top:=LabelT;
        AutoSize:=false;
        Width:=EditL-LabelL;
        Height:=LabelH;
        Parent:=CurPage;
      end;

    // Add an edit field
    E:=TDBShortDate.Create(CurForm);
    with E do
      begin
        Text:='';
        Left:=EditL;
        Top:=EditT;
        AutoSize:=false;
        w:=12*FontH;
        if w>EditW
          then Width:=EditW
          else Width:=w;
        Height:=EditH;
        Parent:=CurPage;
      end;

    // Nove to the next field
    EditT:=EditT+EditN;
    LabelT:=LabelT+EditN;
end;

// ************************************************************************
function sxPrintSectionFlag: boolean;
// This function determiness if the user requested the section being processed to print, 
	
begin

	Result := false;
	if wxSectionNumber=1 then			// errors
		if wxSection1.Checked then
			Result:=true;

	if wxSectionNumber=2 then			// exclusions
		if wxSection2.Checked then
			Result:=true;

	if wxSectionNumber=31 then			// parish
		if wxSection31.Checked then
			Result:=true;

	if wxSectionNumber=32 then			// school
		if wxSection32.Checked then
			Result:=true;

	if wxSectionNumber=33 then			// cemetery
		if wxSection33.Checked then
			Result:=true;

	if wxSectionNumber=4 then			// recap
		if wxSection4.Checked then
			Result:=true;

end;


// ************************************************************************
function sxIsSection(pxSection: string;): integer;
// This function returns the section number being processed.
// Parms: 	pxSection (input) it is the Alternate Number from a Print a new heading line
//			Result	The section value; if it does not match any then it returns zero

begin

	Result := 0;
	case pxSection of
		'00I':  Result := 1;	// Section I - Errors
		'0II':	Result := 2;	// Section II - Diocesan Exclusions
		'III.1':	Result := 31;	// Section III  (.1 = parish)
		'III.2':	Result := 32;	// Section III  (.2 = school)
		'III.3':	Result := 33;	// Section III  (.3 = cemetery)
		'0IV':	Result := 4		// Section IV - Recap
	end;
	
end;

// ************************************************************************
function sxIsDebit(pxTypeVal: integer;): boolean;
// This function returns true if the account type carries a debit normal balance or false is credit normal balance
// Parms: 	pxTypeVal	Account Type Value 	(input)
//			Result	true if debit, false if credit (return)

begin

	case pxTypeVal of
		11:	Result := true;		// asset
		21:	Result := false;	// liability	
		31: Result := false;	// Revenue
		41:	Result := true;		// Expense
		else Result := false;
	end;
	
end;

// ************************************************************************
function sxIsBalSheet(pxTypeVal: integer;): boolean;
// This function returns true if the account type is a balance sheet account; false if not (that is, income statement)
// Parms: 	pxTypeVal	Account Type Value 	(input)
//			Result	true if debit, false if credit (return)

begin

	case pxTypeVal of
		11:	Result := true;		// asset
		21:	Result := true;		// liability	
		31: Result := false;	// Revenue
		41:	Result := false;	// Expense
		else Result := false;
	end;
	
end;

// ************************************************************************
// ************************************************************************
procedure sxWriteBlankMain(pxK1: integer; pxK2: integer; pxSrc: integer; pxMsg: string);
// This function writes a "blank" record to the Main report
//
// Parms: 	pxK1	Section/Page 
//			pxK2	Record Seq#	
//			pxSrc	Group Source specification number: 3=heading, 5=total, 13=detail
//			pxMsg	'Account' description to be printed, if any or can be just '' blank

//	Example: sxWriteBlankMain(k1, k2, 3, 'Test');	// write a "blank" 'heading' record  report record

Begin
	wxRptTbl.Append;
	wxRptTbl.FieldByName('wxRptK1').AsInteger:=pxK1;
	wxRptTbl.FieldByName('wxRptK2').AsInteger:=pxK2;
	wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=0;

	// revised: 5/27/2014:
		wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=0;
	// end revised 5/27/2014
	
	wxRptTbl.FieldByName('wxRptSrc').AsInteger:=pxSrc;
	wxRptTbl.FieldByName('wxRptSrcDesc').AsString:='';
	wxRptTbl.FieldByName('wxRptActNbr').AsString:='';
	wxRptTbl.FieldByName('wxRptAltAct').AsString:='';
	wxRptTbl.FieldByName('wxRptActDesc').AsString:=pxMsg;
	wxRptTbl.FieldByName('wxRptTotalLevel').AsInteger:=0;
	wxRptTbl.FieldByName('wxRptBlankLines').AsInteger:=0;
	wxRptTbl.FieldByName('wxRptNewPage').AsBoolean:=false;
	wxRptTbl.FieldByName('wxRptSection').AsInteger:=wxSectionNumber;; 		// revised: 5/27/2014
	wxRptTbl.Post;

end;

// ************************************************************************
procedure sxWriteBlankSub(pxK1: integer; pxK2: integer, pxVisible);
// This function writes a "blank" record to the sub report
//
// Parms: 	pxK1		Section/Page 
//			pxK2		Record Seq#
//			pxVisible	Visible print flag.  The report writer tests this flag to determine if the sub report 
							// line should print
//	sxWriteBlankSub(k1, k2, false);	// write a "blank" sub report record

Begin
					
	wxSubTbl.Append;
	wxSubTbl.FieldByName('wxSubK1').AsInteger:=pxK1;
	wxSubTbl.FieldByName('wxSubK2').AsInteger:=pxK2;
	wxSubTbl.FieldByName('wxSubK3').AsInteger:=0;	
	wxSubTbl.FieldByName('wxSubActNbr').AsString:='';
	wxSubTbl.FieldByName('wxSubAltAct').AsString:='';
	wxSubTbl.FieldByName('wxSubActDesc').AsString:='';
	wxSubTbl.FieldByName('wxSubMaster').AsBoolean:=false;
	wxSubTbl.FieldByName('wxSubSub').AsBoolean:=false;
	wxSubTbl.FieldByName('wxSubInactive').AsBoolean:=false;
	wxSubTbl.FieldByName('wxSubBalance').AsCurrency:=0;

	// revised: 5/27/2014:
		wxSubTbl.FieldByName('wxSubBudgetYr2').AsCurrency:=0;
	// end revised 5/27/2014
		
	wxSubTbl.FieldByName('wxSubVisible').AsBoolean:=pxVisible;
	wxSubTbl.Post;
	
end;

// ************************************************************************
function sxGetSrcDesc(pxSrc: integer;): string;
// This function returns the source specification description
// Parms: 	pxSrc	Source Spec	(input)
//			Result	Source Spec Description (return)
begin

	Result := '';
	case pxSrc.asInteger of
		0:  Result := 'Print account ';
		1:	Result := 'Include account but hide the detail';
		2:	Result := 'print total of the hidden detail';
		3:	Result := 'Print a new heading account ';
		4:	Result := 'Print amount from total account';
		5:	Result := 'Print a new total account';
		6:	Result := 'Print a new net account';
		7:	Result := 'Print blank line';
		8:	Result := 'Print a sum of the net accounts';
		9:	Result := 'Add in and print account';
		10:	Result := 'Add in account but hide the detail';
		11:	Result := 'Subtract out and print account';
		12:	Result := 'Subtract account but hide the detail';
		13:	Result := 'Print a new detail account';
		14:	Result := 'Print account with alterations';
		15:	Result := 'Print a set of accounts as a single entry';
		16:	Result := 'Include a set of accounts but hide the detail';
		17:	Result := 'Print set of accounts';
		18:	Result := 'Subtract out a set of accounts';
		19:	Result := 'Subtract out a set of accounts but hide the detail';
		20:	Result := 'Add in beg. bal. of account but hide the detail';
		21:	Result := 'Subtract beg. Bal. of account but hide the detail';
		22:	Result := 'Print total of hidden details with alterations'; 
		23: Result := 'Include account but hide the detail with alterations';
		else Result := 'unkown source description';
	end;
end;


// ************************************************************************
procedure sxUpdateSaveTotal(pxAltNumber: string; pxTypeVal: integer; pxDesc: string; pxBalance: currency; pxBudgetYr2: currency);
// Write or Update the wxSaveTotalTbl table with a new total record

// Parms: 	pxAltNumber		Alternate Number	(input)
//			pxTypeVal		Account Type Value	(input)
//			pxpxDesc		Account Description (input)
//			pxBalance		Total Amount		(input)
//			PxBudgetYr2		Annual Budget 		(input)

var	
	wxSearchStr:	string;
	wxMsg:			string;
	
begin	
	//	Test for a given Alternate Number
	//	If record found then
	//		accumulate amount
	//		update record
	//	Else (no record found)
	//		Write record
	//	Endif
	
	wxMsg:='';
	wxSearchStr:=pxAltNumber;
	If  (wxSaveTotalTbl.Locate('wxSvTlAltAct',wxSearchStr,mkset())) then
	begin
		wxSaveTotalTbl.Edit;
		wxSaveTotalTbl.FieldByName('wxSvTlBalance').AsCurrency:=wxSaveTotalTbl.FieldByName('wxSvTlBalance').AsCurrency + pxBalance;
		wxSaveTotalTbl.FieldByName('wxSvtlBudgetYr2').AsCurrency:=pxBudgetYr2;	// revised: 5/27/2014:
	
		wxSaveTotalTbl.Post;
	end	// endif
	else
	begin
		wxSaveTotalTbl.Insert;
		wxSaveTotalTbl.FieldByName('wxSvTlAltAct').AsString:=pxAltNumber;
		wxSaveTotalTbl.FieldByName('wxSvTlTypeVal').AsInteger:=pxTypeVal;
		wxSaveTotalTbl.FieldByName('wxSvTlDesc').AsString:=pxDesc;
		wxSaveTotalTbl.FieldByName('wxSvTlBalance').AsCurrency:=pxBalance;
		wxSaveTotalTbl.FieldByName('wxSvtlBudgetYr2').AsCurrency:=pxBudgetYr2;	// revised: 5/27/2014:
	
		wxSaveTotalTbl.Post;
	end;	// end else

end;	// end sxUpdateSaveTotal


// ************************************************************************
procedure sxWriteStToCoa; 
// Write the Save Total Table (wxSaveTotalTbl) records to the Chart of Accounts Table (wxCoa)
//	this routine is executed immedately upon starting the recap section of the report
//	this allows the use of group specs and the existing code to print the totals 

// Parms: 	(none)

var	
	wxMsg:			string;
	
begin	
	//	For each record on the Save Total Table
		// write a record to the Chart of Accounts table
	
	wxMsg:='';
//	wxCoaTbl.Insert;

	with wxSaveTotalTbl do
	begin
		First;
		while not eof do
		begin
		
			wxCoaTbl.Append;
			wxCoaTbl.FieldByName('wxCoaRecNbr').AsInteger:=0;
			wxCoaTbl.FieldByName('wxCoaActNbr').AsString:='';
			wxCoaTbl.FieldByName('wxCoaAltAct').AsString:=wxSaveTotalTbl.FieldByName('wxSvTlAltAct').AsString;
			wxCoaTbl.FieldByName('wxCoaActDesc').AsString:=wxSaveTotalTbl.FieldByName('wxSvTlDesc').AsString;
			wxCoaTbl.FieldByName('wxCoaActType').AsInteger:=wxSaveTotalTbl.FieldByName('wxSvTlTypeVal').AsInteger;

			if (sxIsBalSheet(wxSaveTotalTbl.FieldByName('wxSvTlTypeVal').AsInteger)) then		// true if balance sheet, false if income statement
				wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean:=true
			else
				wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean:=false;
				
			if (sxIsDebit(wxSaveTotalTbl.FieldByName('wxSvTlTypeVal').AsInteger)) then	//	true if debit, false if credit normal balance
				wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean:=true
			else
				wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean:=false;

			wxCoaTbl.FieldByName('wxCoaMaster').AsBoolean:=false;
			wxCoaTbl.FieldByName('wxCoaSub').AsBoolean:=false;
			wxCoaTbl.FieldByName('wxCoaInactive').AsBoolean:=false;
			wxCoaTbl.FieldByName('wxCoaBalance').AsCurrency:=wxSaveTotalTbl.FieldByName('wxSvTlBalance').AsCurrency;
							
		// revised: 5/27/2014:
			wxCoaTbl.FieldByName('wxCoaBudgetYr2').AsCurrency:=wxSaveTotalTbl.FieldByName('wxSvtlBudgetYr2').AsCurrency;
		// end revised 5/27/2014
	
			wxCoaTbl.Post;
			next;
		end;	// end do while
	end;	// end with

end;	// end sxWriteStToCoa

// ************************************************************************
// function sxGetBalance(pxAltNumber: string; pxK1: integer; pxK2: integer): currency;
function sxGetBalance(pxAltNumber: string; pxK1: integer; pxK2: integer): boolean;

// revised: 5/27/2014:
//	- changed return value to a simple boolean value, because I could not figure out syntax for coding an return array or record
	//	- the global variables wxAltBalTotal and wxBudYr2Total are set by this routine
//	- define wxBudgetYr2 local variable
	
// The purpose of this function:
	// 	- return the balance for a group of accounts with the same alternnate number 
	// 	- write a sub-report record for the supporting COA records
	//	- delete the associated coa records on the wxCoaTbl table
	//	- Accumulate net and sumofnet amounts
	
// Parms: 	pxAltNumber		Alternate Account Number	(input)
//			pxK1			Print Sequence Key		 	(input)
//			pxK2			Record Sequence Key		 	(input)
//			true	(return)

var	
	k3:				integer; 	// sub-report sequence key
	wxSearchStr:	string;		// search string for alternate number
	wxMsg:			string;		// message string
	wxActBalance:	currency;	//	COA Account Balance
	wxBudgetYr2:	currency;	//	COA next fiscal year annual budget
	wxSubVisible:	boolean;	// Used to determine if the sub report line should print
									// note the following for this field:
										// 	Section 4 - recap = false do not print sub report lines
										//	Section 2 - Exclusions = true print sub report lines
										//	User elects to not print sub totals = false 
												// unless section 2, which must print sub report
										
	//		Set Visible flag
	//		Position FP on wxCoaTbl to first record = AlternateNumber
	//		Read record from wxCoaTbl
	//		DoWhile not EOF and Same AlternateNumber
	//			Test for and Accumulate Net and SumOfNets
	//				Add to net if Asset or Revenue
	//				Subtact from net if Liability or Expense
	//			Test for account type normal balance to determine proper sign of the account balance
	//				This is accomplished by knowing in advance the type of balance that is expected
	//				The global boolean variable wxIsDebit is set in the "Main Line" routine for this purpose.
	//			Accumulate AlternateBalance = COA.AccountBalance
	//			Increment sub-report key 
	//			Write Sub-report table record
	//			Delete the wxCoaTbl record
	//			Read another record from wxCoaTbl = AlternateNumber
	//		EndDoW

begin

// revised: 5/27/2014:
	// clear global and local variables 
	wxAltBalTotal:=0;
	wxBudYr2Total:=0;
	wxBudgetYr2:=0;
// end revised 5/27/2014
	
	wxActBalance:=0;
	k3:=0;
	wxSearchStr:='';
	
	wxSubVisible:=true;
	if (wxSectionNumber=4) then
		wxSubVisible:=false;
		
	if (wxExcludeSubRpt.Checked) then
		wxSubVisible:=false;

	if (wxSectionNumber=2) then
		wxSubVisible:=true;

	with wxCoaTbl do
    begin
		First;
		wxSearchStr:=pxAltNumber.AsString;
		wxCoaTbl.Locate('wxCoaAltAct',wxSearchStr,mkset());
		while (not eof) and (wxCoaTbl.FieldByName('wxCoaAltAct').AsString = pxAltNumber.AsString) do
		begin

			// test for and accumulate to net and subofnets.  Reverse sign if liability or expense so net surplus/deficit accumulates correctly
			wxActBalance:=wxCoaTbl.FieldByName('wxCoaBalance').AsCurrency;
			wxBudgetYr2:=wxCoaTbl.FieldByName('wxCoaBudgetYr2').AsCurrency;	// revised: 5/27/2014: 

			if ((wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean) and (not wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean))	then 
			begin
				wxActBalance:=wxActBalance * -1;	// liability, flip the sign
				wxBudgetYr2:=wxBudgetYr2 * -1;		// revised: 5/27/2014: probably unnecessary because balance sheet accounts do not have budgets
			end;
			if ((not wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean) and (wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean))	then 
			begin
				wxActBalance:=wxActBalance * -1;	// expense, flip the sign
				wxBudgetYr2:=wxBudgetYr2 * -1;		// revised: 5/27/2014:
			end;
			
			wxNet:=wxNet+wxActBalance;
			wxSumOfNets:=wxSumOfNets+wxActBalance;
			wxNetBudgetYr2:=wxNetBudgetYr2+wxBudgetYr2;	// revised: 5/27/2014:
			wxSONBudgetYr2:=wxSONBudgetYr2+wxBudgetYr2;	// revised: 5/27/2014:
			
			// get the account balance again, test for sign of amount field and flip sign if necessary such that accounts with abnormal balances 
			// appear as negative amounts on the report
			wxActBalance:=wxCoaTbl.FieldByName('wxCoaBalance').AsCurrency;
			wxBudgetYr2:=wxCoaTbl.FieldByName('wxCoaBudgetYr2').AsCurrency;	// revised: 5/27/2014:
			if (wxIsDebit <> wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean) then
			begin
				wxActBalance:=wxActBalance * -1;
				wxBudgetYr2:=wxBudgetYr2 * -1;	// revised: 5/27/2014:
			end;				
				
			// add sub report record if the section should print
			inc(k3);
			if (sxPrintSectionFlag) then
			begin
				wxSubTbl.Append;
				wxSubTbl.FieldByName('wxSubK1').AsInteger:=pxK1;
				wxSubTbl.FieldByName('wxSubK2').AsInteger:=pxK2;
				wxSubTbl.FieldByName('wxSubK3').AsInteger:=k3;
				wxSubTbl.FieldByName('wxSubActNbr').AsString:=wxCoaTbl.FieldbyName('wxCoaActNbr').AsString;
				wxSubTbl.FieldByName('wxSubAltAct').AsString:=pxAltNumber.AsString;
				wxSubTbl.FieldByName('wxSubActDesc').AsString:=wxCoaTbl.FieldbyName('wxCoaActDesc').AsString;
				wxSubTbl.FieldByName('wxSubMaster').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaMaster').AsBoolean;
				wxSubTbl.FieldByName('wxSubSub').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaSub').AsBoolean;
				wxSubTbl.FieldByName('wxSubInactive').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaInactive').AsBoolean;
				wxSubTbl.FieldByName('wxSubBalance').AsCurrency:=wxActBalance;
				wxSubTbl.FieldByName('wxSubBudgetYr2').AsCurrency:=wxBudgetYr2;	// revised: 5/27/2014:
				wxSubTbl.FieldByName('wxSubVisible').AsBoolean:=wxSubVisible;
				wxSubTbl.Post;
			end;
			
			// accumulate alternate account balance and budget amounts for return 
			wxAltBalTotal:=wxAltBalTotal+wxActBalance;	// revised: 5/27/2014:
			wxBudYr2Total:=wxBudYr2Total+wxBudgetYr2;	// revised: 5/27/2014:

			// delete the current record form the COA table, thus showing that the record has been processed
			wxCoaTbl.Delete;	// this appears to not only delete the 'current' record, but move the FP to the next record, thus the wxcoatbl.next line is not needed
//			wxCoaTbl.next;

		end;	// end doWhile wxCoaTbl
	end;	// end with wxCoaTbl
	
	// if no records were written to the sub report table and PrintAnnualReport flag = true then 
		// write one "no records found" record; this step is important because without a related sub-record the master record will not print
	if ((k3 = 0) and (sxPrintSectionFlag)) then
	begin
		wxSubTbl.Append;
		wxSubTbl.FieldByName('wxSubK1').AsInteger:=pxK1;
		wxSubTbl.FieldByName('wxSubK2').AsInteger:=pxK2;
		wxSubTbl.FieldByName('wxSubK3').AsInteger:=k3;
		wxSubTbl.FieldByName('wxSubActNbr').AsString:='';
		wxSubTbl.FieldByName('wxSubAltAct').AsString:='';
		wxSubTbl.FieldByName('wxSubActDesc').AsString:='no records on file for alt# '+ pxAltNumber.AsString;
		wxSubTbl.FieldByName('wxSubMaster').AsBoolean:=false;
		wxSubTbl.FieldByName('wxSubSub').AsBoolean:=false;
		wxSubTbl.FieldByName('wxSubInactive').AsBoolean:=false;
		wxSubTbl.FieldByName('wxSubBalance').AsCurrency:=0;

		// revised: 5/27/2014:
			wxSubTbl.FieldByName('wxSubBudgetYr2').AsCurrency:=0;
		// end revised 5/27/2014

		wxSubTbl.FieldByName('wxSubVisible').AsBoolean:=wxSubVisible;
		wxSubTbl.Post;
	end;	// end if no records
	
	Result:=true; // revised: 5/27/2014:
	
end;	// end function sxGetBalance

// ************************************************************************
procedure sxUpdateTLevel(pxTLevel: integer; pxBalance: currency; pxBudgetYr2: currency);
// This function updates the Total Level Table wxTLevelTbl with a new amount
//	Revised: 5/27/2014: added budget amount to parm list and update table

// Parms: 	pxTLevel		Total Level	(input)
//			pxBalance		Amount	(input)
//			pxBudgetYr2		budget amount (input)

var	
	wxSearchStr:	string;	// search string
	wxMsg:	string;		// message string

begin	
	//	Test for a given Total Level Value
	//	If record found then
	//		accumulate amount
	//		update record
	//	Else (no record found)
	//		Write record
	//	Endif
	
	wxMsg:='';
	wxSearchStr:=IntToStr(pxTLevel);
	If  (wxTLevelTbl.Locate('wxTLevel',wxSearchStr,mkset())) then
	begin
		wxTLevelTbl.Edit;
		wxTLevelTbl.FieldByName('wxTBalance').AsCurrency:=wxTLevelTbl.FieldByName('wxTBalance').AsCurrency + pxBalance;
		wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency:=wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency + pxBudgetYr2;	// revised: 5/27/2014:
		wxTLevelTbl.Post;
	end	// endif
	else
	begin
		wxTLevelTbl.Insert;
		wxTLevelTbl.FieldByName('wxTLevel').AsInteger:=pxTLevel;
		wxTLevelTbl.FieldByName('wxTBalance').AsCurrency:=pxBalance;
		wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency:=wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency + pxBudgetYr2;	// revised: 5/27/2014
		wxTLevelTbl.Post;
	end;	// end else

end;	// end sxUpdateTLevel

// ************************************************************************
function sxGetTLevel(pxTLevel: integer;):	currency;
// revised: 5/27/2014:
	// changed function to return a simply boolean value;  the global vars wxAltBalTotal and wxBudYr2Total are set by this function 

// This function retrieves an amount from the Total Level Table wxTLevelTbl
//  It does this by reading all total records with a level less than the specified parm
//  It will then write the amount back to the table for the specified total level back, such
//  that the next total level is accumulating. 
//
// Parms: 	pxTLevel		Total Level	(input)
//			true (return)

var	
	wxMsg:	string;		// message string

begin	
	// revised: 5/27/2014:
		Result:=true;	
		wxAltBalTotal:=0;
		wxBudYr2Total:=0;
	// end revised 5/27/2014
	
	wxMsg:='';

	//	Read TLevel Table
	//	Do While not EOF
	//		If the table Total Level *LT given Total Level then
		//		accumulate result amount
		//		Clear table amount field
		//		update table
		//	End if
		//	Read next record on TLevel Table
	// end DoWhile
	// Write the result back to the table for the given Total Level
	
	with wxTLevelTbl do
    begin
      First;
      while not eof do
      begin
	  	if (wxTLevelTbl.FieldByName('wxTLevel').AsInteger < pxTLevel) then
		begin
			// revised: 5/27/2014:
				//	Result:=Result+wxTLevelTbl.FieldByName('wxTBalance').AsCurrency;
				wxAltBalTotal:=wxAltBalTotal+wxTLevelTbl.FieldByName('wxTBalance').AsCurrency;
				wxBudYr2Total:=wxBudYr2Total+wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency;
			// end revised 5/27/2014
			wxTLevelTbl.Edit;
			wxTLevelTbl.FieldByName('wxTBalance').AsCurrency:=0;
			wxTLevelTbl.FieldByName('wxTBudgetYr2').AsCurrency:=0;	// revised: 5/27/2014:
			wxTLevelTbl.Post;
		end;	// end if
		next;
	  end;	// end DoWhile
	end; // end do
	sxUpdateTLevel(pxTLevel, wxAltBalTotal, wxBudYr2Total);	// revised: 5/27/2014:

end;	// end sxGetTLevel

	
// ***********************************************************************
procedure sxSectionI;
	// Process and Print Section I - Errors
					
	//	At this point all the group records have been processed and records on the Chart of Accounts table wxCoaTbl that have a valid Alternate Number
	//	have been processed (that is, deleted).  Thus, the only records left on the Chart of Account table wxCoaTbl have invalid Alternate Numbers: 
	//	which are blank, zero, or not defined to the group.  This routine processes these records. 

var
	k1:	integer;	// Print Sequence
	k2:	integer;	// Record Sequence
	k3:	integer;	// sub-record sequence
	wxErrorCtr: integer;	// error record counter (invalid alternate numbers)
	wxSaveSectionNumber:	integer;	// preserve the section number from the calling routine and restore on leaving

Begin

	// this section is called after section 3 is processed, but before section 4 is processed.  Preserve the value of
	//	the section number from the calling routine, even though it's value is probably 4, do it this way to 
	//	allow future expanion without programming (hopefully). 
	wxSaveSectionNumber:=wxSectionNumber;
	wxSectionNumber:=1;		// section = 1 - Errors
	
	//	Write heading report detail and sub "blank" records
	if sxPrintSectionFlag then
	begin
		k1:=1;
		k2:=1;
		sxWriteBlankMain(k1, k2, 3, 'Part I - Errors and Exceptions');	
		sxWriteBlankSub(k1, k2, false);	// write a "blank" sub report record
		
		k2:=2;
		sxWriteBlankMain(k1, k2, 3, 'This section list accounts that have invalid, blank, or zero alternate account numbers');	
		sxWriteBlankSub(k1, k2, false);	// write a "blank" sub report record
	end;

// note: all 'error' records (main and sub) for this section must have a K2 key value = 3, as the two 'heading' lines just written have values 1 and 2.
	//	Init Section/Page key = 1 and main record key = 2
	//	Init error counter
	//	write a blank main record to associate with the subreport records to be written (if any) 	
	//	Position FP for wxCoaTbl to first record
	// 	Read wxCoaTbl record
	//	DoWhile not EOF
	//		Count Error;	
	//		Set Sub Record Seq = Error Counter
	//		Move fields to output; write the sub report record
	//		Delete the record from the wxCoaTbl table; this is necessary to clear the table to write the totals records and print the recap
	//		Read another wxCoaTbl record
	//	EndDoW
	//	write one more subreport record just in case no subreport error records were actually written, this will allow 
		// the main and subreport records to associate with each other.

	k1:=1;
	k2:=3;
	wxErrorCtr:=0;
	if sxPrintSectionFlag then
		sxWriteBlankMain(k1, k2, 13, '');

	with wxCoaTbl do
    begin
      First;
      while not eof do
      begin
		inc(wxErrorCtr);
		k3:=wxErrorCtr;
		
		if sxPrintSectionFlag then
		begin
			wxSubTbl.Append;
			wxSubTbl.FieldByName('wxSubK1').AsInteger:=k1;
			wxSubTbl.FieldByName('wxSubK2').AsInteger:=k2;
			wxSubTbl.FieldByName('wxSubK3').AsInteger:=k3;
			wxSubTbl.FieldByName('wxSubActNbr').AsString:=wxCoaTbl.FieldbyName('wxCoaActNbr').AsString;
			wxSubTbl.FieldByName('wxSubAltAct').AsString:=wxCoaTbl.FieldbyName('wxCoaAltAct').AsString;
			wxSubTbl.FieldByName('wxSubActDesc').AsString:=wxCoaTbl.FieldbyName('wxCoaActDesc').AsString;
			wxSubTbl.FieldByName('wxSubMaster').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaMaster').AsBoolean;
			wxSubTbl.FieldByName('wxSubSub').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaSub').AsBoolean;
			wxSubTbl.FieldByName('wxSubInactive').AsBoolean:=wxCoaTbl.FieldbyName('wxCoaInactive').AsBoolean;
			wxSubTbl.FieldByName('wxSubBalance').AsCurrency:=wxCoaTbl.FieldbyName('wxCoaBalance').AsCurrency;
			wxSubTbl.FieldByName('wxSubVisible').AsBoolean:=true;			
			wxSubTbl.Post;
		end;
		wxCoaTbl.Delete;
		
      end;	// end dow not eof
    end;	// end do with

	// If the Error Counter = 0 then
		// write one blank 'sub' report record to associate with the main report record already written
		// write "no errors found" message
	if (wxErrorCtr=0) then
	begin
		sxWriteBlankSub(k1, k2, false);
		k2:=4;
		sxWriteBlankMain(k1, k2, 3, 'No errors found.');
		sxWriteBlankSub(k1, k2, false);
	end;
	
	// restore the section number
	wxSectionNumber:=wxSaveSectionNumber;

end;	// end sxSectionI

// ************************************************************************
procedure sxSetParms;
	// pass parms to the report
	
var
	s:	string;
	
begin
	
	PDSSetParam(1,wxCoaGroupName.text);
	PDSSetParam(2,wxYourName.text);

	s:=wxendAsOfDate.text;
	PDSSetParam(3,s);

	PDSSetParam(4,wxUserName);
	PDSSetparam(5,wxChurchName.text);
	PDSSetparam(6,wxCityName.text);
	PDSSetparam(7,wxChurchNumber.text);
	PDSSetparam(8,wxPgmVer);

end;

// ************************************************************************
// Setup and display screen
procedure AfterLoadReport;
	
var
	wxHeading:	string;
	NewPage1: TLMDAssistPage;
	PageLabel,
	wxReportType: TRadioGroup;
	
	IniFile:	TIniFile;	// revised: 5/27/2014:
	wxTChurchNum: string;

begin
	NewScreenPage;
	wxPgmVer:='Version 7.0';
	wxHeading:='Diocese of Buffalo - Financial Report Worksheet, ' + wxPgmVer;
	AddHeading(wxHeading,PageLabel);

//	AddBlank;	
//	AddEdit(s: string; L: TLabel; E: TEdit; N: integer);
	AddEdit('Parish Number:', TLabel, wxChurchNumber, 4);
	AddEdit('Parish Name: ', TLabel, wxChurchName, 40);
	wxChurchName.text:=ownername;
	AddEdit('City Name: ', TLabel, wxCityName, 40);
//	wxCityName.text:=ownercity;
	AddEdit('Your Name: ', TLabel, wxYourName, 40);

//	AddBlank;
	AddHeading('Report Options:',PageLabel);

	AddShortDate('As of Date (Fiscal Year End):',wxDateLabel,wxEndAsOfDate);
	y1:=DM.MainReportMonthNum2 div 12;
	m1:=DM.MainReportMonthNum2 mod 12;
	wxEndAsOfDate.Text:=EncodeShortDate(m1,y1);
	AddCheckBox(' Do not print sub-totals',wxExcludeSubRpt);
		wxExcludeSubRpt.checked:=false;

	AddHeading('Print the following:',PageLabel);
	AddCheckBox('Part I   - Errors and Exceptions',wxSection1);
		wxSection1.checked:=true;

//	AddCheckBox('Section II  - Diocesan Exclusions',wxSection2);
//		wxSection2.checked:=true;

//	AddLabel('Section III - Financial Report');

	AddCheckBox('Part II.1 - School Report',wxSection32);
		wxSection32.checked:=true;
	AddCheckBox('Part II.2 - Parish Report',wxSection31);
		wxSection31.checked:=true;
	AddCheckBox('Part II.3 - Cemetery Report',wxSection33);
		wxSection33.checked:=true;
	AddCheckBox('Part III - Recap',wxSection4);
		wxSection4.checked:=true;

	AddDropDown('COA Group:',TLabel,wxCoaGroupName,40);
	wxCoaGroupName.items.clear;
  // Fill the drop down with the names of the COA Groups
	with DM.GrpTbl do
	begin
		First;
		while not eof do
		begin
			wxCoaGroupName.items.add(DM.GrpTblName.AsString);
			Next;
		end;
	end;
	// Set Default group name in case user does not give specify one
	wxCoaGroupName.text:='DOB_FinancialReportWorksheet(v7.0)';
	
	// revised: 5/27/2014:
	// load report ini file values from last time into screen fields
	IniFile:=TIniFile.Create(trim(DMReport.MainRepName)+'.ini');
	try
		wxChurchNumber.text:=IniFile.ReadString('LastInfo','wxChurchNumber',4);
		wxChurchName.text:=IniFile.ReadString('LastInfo','wxChurchName',40);
		if (wxChurchName.text) = '' then
			wxChurchName.text:=ownername;
		wxCityName.text:=IniFile.ReadString('LastInfo','wxCityName',40);
		wxYourName.text:=IniFile.ReadString('LastInfo','wxYourName',40);
		wxIniFieldsRead:=true;
	finally
		IniFile.Free;
		IniFile:=nil;
	end;
	// end revised: 5/27/2014:

	sxSetParms;
	
end;

// ************************************************************************
// Initialize the tables
procedure AfterCreateReport;
begin
	wxRptTbl:=nil;
	wxRptDS:=nil;
	wxRptPL:=nil;
	
	wxSubTbl:=nil;
	wxSubDS:=nil;
	wxSubPL:=nil;
	
	wxCoaTbl:=nil;
	wxTLevelTbl:=nil;
	wxSaveTotalTbl:=nil;
	
	wxIniFieldsRead:=false;	// revised: 5/27/2014:

end;

// ************************************************************************
//	Define the tables
procedure CreateExternalData;
begin

	// **********  Define the Report Main Detail Line table and fields; most of the record field values are 
			//	obtained from Group Table: DM.GrpTbl
	wxRptTbl:=TKbmMemTable.Create(DMReport);
	with wxRptTbl do
	begin
		FieldDefs.Clear;
		// the following two fields are assigned by this program:
		FieldDefs.Add('wxRptK1', ftInteger, 0, False);		// Print Sequence #, Valid values:
																	// its primary purpose is to sub-divided the report into major sections;
																	//	each section is started on a new page.	
																	//	1 = Errors (invalid or blank Alt#)
																	//	2 = Ignore (alt# = 999.9, user specified to ignore a record for the report
																	//	3 and above = Annual Report Specs
		FieldDefs.Add('wxRptK2', ftInteger, 0, False);		// Record Sequence#: keeps records in proper order within the Section/Page Sequence; 
																// This is incremented for each unique Alternate Account
		FieldDefs.Add('wxRptAltBalance', ftCurrency, 0, False);	// the accumulated balances of a given Alternate Account
		// revised: 5/27/2014:
			FieldDefs.Add('wxRptBudgetYr2', ftCurrency, 0, False);	// the accumulated next fiscal year budget balances of a given Alternate Account
		// end revised 5/27/2014
		// the following fields are obtained from the Group:
		FieldDefs.Add('wxRptSrc', ftInteger, 0, False);			// Group specification, i.e. source spec number (see next field wxGrpSrcDesc)
																	// 3=heading, 5=total, 6=net, 7=blank
		FieldDefs.Add('wxRptSrcDesc', ftString, 55, False);		// Group specification Description, i.e. source spec description, e.g. Print Account
		FieldDefs.Add('wxRptActNbr', ftString, 12, False);		// Account number; this field is not used in the annual report group list
		FieldDefs.Add('wxRptAltAct', ftString, 12, False);		// Alternate Account Number; this is the number xxx.x on the annual report
		FieldDefs.Add('wxRptActDesc', ftString, 100, False);		// Account Description
		FieldDefs.Add('wxRptTotalLevel', ftInteger, 0, False);	// Total Level
		FieldDefs.Add('wxRptBlankLines', ftInteger, 0, False);	// Blank Lines After
		FieldDefs.Add('wxRptNewPage', ftBoolean, 0, False);		// New Page After
		
		// revised: 5/27/2014
		FieldDefs.Add('wxRptSection', ftInteger, 0, False);		// Section Number, as xlated from sxIsSection() function; indicates the section being printed
																	// and directly related to the alternate account number in the group spec for a section
		// end revised 5/27/2014
	
		IndexDefs.Add('', 'wxRptK1; wxRptK2', MKSet(ixPrimary));
		IndexFieldNames:='wxRptK1; wxRptK2';

		CreateTable;
		Active:=true;
	end;

		//Create Data Source and Pipelinefor Report Table
		wxRptDS:=TDataSource.Create(DMReport);
		wxRptDS.DataSet:=wxRptTbl;
		
		wxRptPL:=TppDBPipeline.Create(DMReport);
		wxRptPL.Name:='wxRptPL';	
		wxRptPL.UserName:='wxRptRpt';  // The name users see
		wxRptPL.DataSource:=wxRptDS;
		wxRptPL.AutoCreateFields := true;

	// ********** Define the Sub-Report table and fields; most of the record field values in this table are 
	//		obtained from the Chart of Accounts table: DM.CoaTbl
	wxSubTbl:=TKbmMemTable.Create(DMReport);
	with wxSubTbl do
	begin
		FieldDefs.Clear;
		
		// the following fields are assigned by this program:
		FieldDefs.Add('wxSubK1', ftInteger, 0, False);		// Section/Page Sequence (wxRptTbl for definition); must match wxRptTlb.wxSubK1 field value			
		FieldDefs.Add('wxSubK2', ftInteger, 0, False);		// Record Sequence# (wxRptTbl for definition); must match wxRptTlb.wxSubK2 field value
		FieldDefs.Add('wxSubK3', ftInteger, 0, False);		// Sub-Record Sequence#: groups within a given K2 key; 
																// keeps related chart records with the same Alt# together
		
		// the following fields are obtained from DM.CoaTbl:
		FieldDefs.Add('wxSubActNbr', ftString, 12, False);		// Account number
		FieldDefs.Add('wxSubAltAct', ftString, 12, False);		// Alternate Account Number
		FieldDefs.Add('wxSubActDesc', ftString, 50, False);		// Account Description
		FieldDefs.Add('wxSubMaster', ftBoolean, 0, False);		// Is Master
		FieldDefs.Add('wxSubSub', ftBoolean, 0, False);			// Is Sub
		FieldDefs.Add('wxSubInactive', ftBoolean, 0, False);	// Inactive
		FieldDefs.Add('wxSubBalance', ftCurrency, 0, False);	// YTD Balance; obtained from the DM.CoaTotalsTbl
		FieldDefs.Add('wxSubBudgetYr2', ftCurrency, 0, False);	//	revised: 5/27/2014: the budget balances obtained from the DM.CoaTotalsTbl['BUDGETYEAR2']
		FieldDefs.Add('wxSubVisible', ftBoolean, 0, False);		//	Sub Report Line Visible
			// note: this field is used to signal to the report writer when the sub report line should be
			//	printed (i.e., visible).  In most cases this value is set to true (i.e., print the line). 
			//	However, the following is noted:
				//	User can elect to not print subtotals, therefore the value is false; but only 
					// applies to Detail (grp source = 13)
				//	Headings (grp source = 3) value is false
				//	Totals (grp source = 5) value is false
				//	Net (grp source = 6) value is false
				//	Section 1 - Errors  - value must be true because the errors accouts are in the sub report.
				//	Section 2 - Exclusions - value must be true to show accounts which are in the sub report.
				//	Section 4 - Recap - value must be false to prevent the sub report lines from printing.

		IndexDefs.Add('', 'wxSubK1; wxSubK2; wxSubk3', MKSet(ixPrimary));
		wxSubTbl.IndexFieldNames:='wxSubK1; wxSubK2; wxSubk3';
		CreateTable;
		Active:=true;
	end;

		//Create Data Source and Pipeline for Sub-Report Table
		wxSubDS:=TDataSource.Create(DMReport);
		wxSubDS.DataSet:=wxSubTbl;
		
		wxSubPL:=TppDBPipeline.Create(DMReport);
		wxSubPL.Name:='wxSubPL';	
		wxSubPL.UserName:='wxSubRpt';  // The name users see
		wxSubPL.DataSource:=wxSubDS;
		wxSubPL.AutoCreateFields := true;
		
		wxSubTbl.MasterSource:=wxRptDS;
		wxSubTbl.MasterFields:='wxRptK1; wxRptK2';


	// ********** Define the Chart table and fields; records are obtained from the Chart of Accounts Table: DM.CoaTbl
	wxCoaTbl:=TKbmMemTable.Create(DMReport);
	with wxCoaTbl do
	begin
		FieldDefs.Clear;
		FieldDefs.Add('wxCoaRecNbr', ftInteger, 0, False);		// Record Number; real-key for the Chart of Account table DM.CoaTbl
		FieldDefs.Add('wxCoaActNbr', ftString, 12, False);		// Account number
		FieldDefs.Add('wxCoaAltAct', ftString, 12, False);		// Alternate Account Number
		FieldDefs.Add('wxCoaActDesc', ftString, 50, False);		// Account Description
		FieldDefs.Add('wxCoaActType', ftInteger, 0, False);		// Account Type
		FieldDefs.Add('wxCoaBalSheet', ftBoolean, 0, False);	// Balance Sheet if true, Income Statement if false
		FieldDefs.Add('wxCoaDrNormal', ftBoolean, 0, False);	// Normal Debit Balance when true; Normal Credit Balance when false
		FieldDefs.Add('wxCoaMaster', ftBoolean, 0, False);		// Is Master
		FieldDefs.Add('wxCoaSub', ftBoolean, 0, False);			// Is Sub
		FieldDefs.Add('wxCoaInactive', ftBoolean, 0, False);	// Inactive
		FieldDefs.Add('wxCoaBalance', ftCurrency, 0, False);	// YTD Balance; obtained from the DM.CoaTotalsTbl
		// revised: 5/27/2014:
			FieldDefs.Add('wxCoaBudgetYr2', ftCurrency, 0, False);	// obtained from the DM.CoaTotalsTbl['BUDGETYEAR2']
		// end revised 5/27/2014
		
		IndexDefs.Add('', 'wxCoaAltAct; wxCoaActNbr', MKSet(ixPrimary));
		wxCoaTbl.IndexFieldNames:='wxCoaAltAct; wxCoaActNbr';
		CreateTable;
		Active:=true;
	end;

	// ********** Setup the Total Level Table
	wxTLevelTbl:=TKbmMemTable.Create(DMReport);
	with wxTLevelTbl do
		begin
			FieldDefs.Clear;
			FieldDefs.Add('wxTLevel', ftInteger, 0, False);		// Total Level; primary key
			FieldDefs.Add('wxTBalance', ftCurrency, 0, False);	// Total Level Balance
			// revised: 5/27/2014:
				FieldDefs.Add('wxTBudgetYr2', ftCurrency, 0, False);	// Next Fiscal Yr Budget total
			// end revised 5/27/2014
			
			IndexDefs.Add('', 'wxTLevel', MKSet(ixPrimary));
			wxTLevelTbl.IndexFieldNames:='wxTLevel';
			CreateTable;
			Active:=true;
		end;

	// ********** Setup the Save Totals Table
	wxSaveTotalTbl:=TKbmMemTable.Create(DMReport);
	with wxSaveTotalTbl do
		begin
			FieldDefs.Clear;
			FieldDefs.Add('wxSvTlAltAct', ftString, 12, False);	// Alternate Account Number
			FieldDefs.Add('wxSvTlTypeVal', ftInteger, 0, False);	// Account Type Value
			FieldDefs.Add('wxSvTlDesc', ftString, 50, False);	// Account Desc (the description of the write a new total account group list spec
			FieldDefs.Add('wxSvTlBalance', ftCurrency, 0, False);	// Total Balance
			// revised: 5/27/2014:
				FieldDefs.Add('wxSvTlBudgetYr2', ftCurrency, 0, False);	// Next Fiscal Yr Budget total
			// end revised 5/27/2014

			IndexDefs.Add('', 'wxSvTlAltAct', MKSet(ixPrimary));
			wxSaveTotalTbl.IndexFieldNames:='wxSvTlAltAct';
			CreateTable;
			Active:=true;
		end;

end;

// ************************************************************************
//	Clear the tables
procedure FreeExternalData;
begin

	if assigned(wxRptTbl)
		then wxRptTbl.Free;
	if assigned(wxRptDS)
		then wxRptDS.Free;
	if assigned(wxRptPL)
		then wxRptPL.Free;
		
	if assigned(wxSubTbl)
		then wxSubTbl.Free;
	if assigned(wxSubDS)
		then wxSubDS.Free;
	if assigned(wxSubPL)
		then wxSubPL.Free;
		
	if assigned(wxCoaTbl)
		then wxCoaTbl.Free;
		
	if assigned(wxTLevelTbl)
		then wxTLevelTbl.Free;

	if assigned(wxSaveTotalTbl)
		then wxSaveTotalTbl.Free;

end;

// ************************************************************************
// ************************************************************************
// ************************************************************************
//	This is the "Main Line" procedure.

procedure AfterSelectionsBuilt;

var 
	k1:	integer;	// Print/Section Sequence
	k2:	integer;	// Record Sequence
	k3:	integer;	// sub-record sequence
	wxSaveK1: integer;	// saved value of k1
	
	i1: integer;		// main record counter
	
	wxIgnoreCtr: integer;		// Ignore record counter (alternate number = 999.9)
	
	wxSearchStr:	string;		// search by string
	wxSearchInt:	integer;	// search by integer
	wxMsg:			string;		// general message used for debugging
	wxGrpId:		integer;	// Group Id real key assocated with the selected Group Name
	wxAltBalance:	currency;	// total balance for a given alternate account number
	wxBudgetYr2:	currency;	// revised: 5/27/2014: next year annual budget
	wxNewPageAfter:	boolean;	// controls Section page breaks
	wxResult:		boolean;		// revised: 5/27/2014; return result for sxGetBalances();

begin

	k1:=0;
	k2:=0;
	k3:=0;
	wxSaveK1:=0;
	i1:=0;
	wxSearchStr:='';
	wxSearchInt:=0;
	wxMsg:='';
	wxAltBalance:=0;
	wxBudgetYr2:=0;
	wxUserName:=UserName;		// User name Ledger associates with user
	wxNewPageAfter:=false;
	wxIsDebit:=true;			// the type of accounts begin processed in the group
	wxNet:=0;
	wxSumOfNets:=0;
	wxNetBudgetYr2:=0;		// revised: 5/27/2014:
	wxSONBudgetYr2:=0;		// revised: 5/27/2014:
	wxResult:=true;			// revised: 5/27/2014:

// *************************************
//  Set Report As Of Date Parms for YTD balances:
	
	DecodeShortDate(wxEndAsOfDate.Text,m1,y1);
	DM.MainReportMonthNum2:=y1*12+m1;

	// Set start dates for the selected fiscal year
		//  Extract the fiscal year start month
		//	Set start year = end year
		//  If the selected month < fiscal year start month then
			// Start Year = End Year - 1
			// Set Report Start Date and Fiscal Start Date fields
	m2:=DM.MainReportFiscalMonthNum mod 12;
	y2:=y1;
	if (m1 < m2) then
		y2:=y1 - 1;
	if (y2 < 0) then
		y2:=0;
	DM.MainReportMonthNum1:=y2*12+m2;
	DM.MainReportFiscalMonthNum:=y2*12+m2;
	

// *************************************
	// pass parms to report
	sxSetParms;
// *************************************
	
	// Initialize the tables: this is required if the user pressed the "back" button after preview.
	wxRptTbl.active:=false; 
	wxRptTbl.EmptyTable; 
	wxRptTbl.Active:=true;

	wxSubTbl.active:=false;
	wxSubTbl.EmptyTable; 
	wxSubTbl.Active:=true;

	wxCoaTbl.active:=false;
	wxCoaTbl.EmptyTable; 
	wxCoaTbl.Active:=true;

	wxTLevelTbl.active:=false; 
	wxTLevelTbl.EmptyTable; 
	wxTLevelTbl.Active:=true;

	wxSaveTotalTbl.active:=false;
	wxSaveTotalTbl.EmptyTable;
	wxSaveTotalTbl.Active:=true;

// ******************************************************************************************************
// ******************************************************************************************************
  // Fill the Chart of Accounts Table wxCoaTbl
  // Only process "detail" records, that is, those that can have transaction posted to
  //	note: if a parish uses Master/Sub accounts, exclude Master accounts as well because they are considered "detail", yet they cannot be posted to.
  
  DM.CoaTbl.Filtered:=false;	// this is suppose to override any user-specified filters
  with DM.CoaTbl do
    begin
      First;
	  i1:=0;
      while not eof do
      begin
		// if detail 
		if ((DM.COATbl['IsDetail']) and (not DM.COATbl['MasterAccount'])) then
		begin
			inc(i1);
			wxCoaTbl.Append;
			wxCoaTbl.FieldByName('wxCoaRecNbr').AsInteger:=DM.CoaTblCoaRec.AsInteger;
			wxCoaTbl.FieldByName('wxCoaActNbr').AsString:=DM.CoaTblNumber.AsString;
			wxCoaTbl.FieldByName('wxCoaAltAct').AsString:=DM.COATblAlternateNumber.AsString;
			wxCoaTbl.FieldByName('wxCoaActDesc').AsString:=DM.CoaTblName.AsString;
			wxCoaTbl.FieldByName('wxCoaActType').AsInteger:=DM.CoaTblTypeVal.AsInteger;
			
			if (DM.COATbl['IsBalanceSheet']) then		// true if balance sheet, false if income statement
				wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean:=true
			else
				wxCoaTbl.FieldByName('wxCoaBalSheet').AsBoolean:=false;


			if (DM.COATbl['IsDebit']) then
				wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean:=true	// debit normal balance
			else
				wxCoaTbl.FieldByName('wxCoaDrNormal').AsBoolean:=false;	// credit normal balance

			wxCoaTbl.FieldByName('wxCoaMaster').AsBoolean:=DM.COATblMasterAccount.AsBoolean;
			wxCoaTbl.FieldByName('wxCoaSub').AsBoolean:=DM.COATblSubAccount.AsBoolean;
			wxCoaTbl.FieldByName('wxCoaInactive').AsBoolean:=DM.COATblInactive.AsBoolean;
			wxCoaTbl.FieldByName('wxCoaBalance').AsCurrency:=0;
			// revised: 5/27/2014:
				wxCoaTbl.FieldByName('wxCoaBudgetYr2').AsCurrency:=0;
			// end revised 5/27/2014

				// Get YTD Balance:
				wxSearchInt:=DM.CoaTblCoaRec.AsInteger;
				if DM.CoaTotalsTbl.Locate('CoaRec',wxSearchInt,mkset()) then
				begin
					wxCoaTbl.FieldByName('wxCoaBalance').AsCurrency:=DM.CoaTotalsTblYTDAmount.AsCurrency;
					// revised: 5/27/2014:
					// Note: balance sheet accounts do not have budgets, hope this code simply returns zero for those situations
						wxCoaTbl.FieldByName('wxCoaBudgetYr2').AsCurrency:=DM.CoaTotalsTblBudgetYear2.AsCurrency;
					// end revised 5/27/2014
				end;	// end if record locate

			wxCoaTbl.Post;
			
		end;	// end if detail
		Next;
      end;	// end dowhile not eof
//	  wxMsg:= 'Chart of Account Records Loaded = ' + IntToStr(i1);
//	  showMessage(wxMsg);
    end;

// ******************************************************************************************************
// ******************************************************************************************************
	// Process the Group List spec 
	
	// Get the Group Id Key associated with the selected Group Name
		// Very Important Note: the DM.GrpTbl (list of group names) and the DM.GrpCoaTbl (group specifications) 
		// are "joined" together; apparently the script cannot override this.  Therefore, reading a record from
		// DM.GrpTbl will automatically select the related records from DM.GrpCoaTbl.  The "break" statement 
		// in the code is important as it will leave the file pointer at the desired group record and thus the 
		// associated group spec records will be automaticially made available to this script.  Thus, do NOT
		//	remove the "break", doing so will cause the report to select the wrong records.
	with DM.GrpTbl do
	begin
		First;
		while not eof do
		begin
			if (wxCoaGroupName.Text = DM.GrpTblName.AsString) then
			begin
				wxGrpId:=DM.GrpTblGrpListRec.AsInteger;
				break;
			end;
			Next;
		end;
	end;
	
//	wxMsg:= 'Group Name: ' + wxCoaGroupName.Text + '; Group Id: ' + IntToStr(wxGrpId);
//	showMessage(wxMsg);
	
	// Set Print Sequence Key K1 = 3 (Annual Report).  This field will be increment for each section; this is determined by the wxRptNewPage field = true.
	// Turn user specified filters off
	// 	Read COA Groups File
	//	DoWhile not EOF
	//		If selected group then
	//			Increment Record Sequence Key K2
	//			Process various record types

	i1:=0;
	k1:=3;
	k2:=0;
	with DM.GrpCoaTbl do
    begin
      First;
      while not eof do
      begin

// Note the following code is commented out.  It is not necessary to test if the group list key matches (see the note at the start
// of this section.  I have left the code in but commented out, for possible future consideration or testing.

//	  	inc(i);
//	  	wxMsg:='Inside While Do: i= ' + IntToStr(i) + '; Group Key= ' + IntToStr(DM.GrpCoaTblGrpListRec.AsInteger);
//		showmessage(wxMsg);
			
//		if (wxGrpId = DM.GrpCoaTblGrpListRec.AsInteger) then 
//		begin
			
//			inc(i1);
//		  	wxMsg:='Inside If: i2= ' + IntToStr(i2) + '; Group Key= ' + IntToStr(DM.GrpCoaTblGrpListRec.AsInteger);
//			showmessage(wxMsg);
			
			inc(k2);
			wxNewPageAfter:=false;	// set this to false, this is tested after the record is processed 
			
			// if Heading then
			if (DM.GrpCoaTblGrpSource.AsInteger = 3) then
			begin
			
				// If a Section is indicated then 
					// Set Section Number
					// Set SectionState = true;
				if ((DM.GrpCoaTblAlternateNumber.AsString <> '') and (DM.GrpCoaTblAlternateNumber.AsString <> '000')) then
				begin
					wxSectionNumber:=sxIsSection(DM.GrpCoaTblAlternateNumber.AsString);
					wxSectionState:=true;
				end;

				// if an account type is specified (it is not specified for every heading) then
					// Save the type value to the global variable
					//	Test for and set Normal Debit/Credit
				if (DM.GrpCoaTblTypeVal.AsInteger <> 0) then
				begin
					wxTypeVal:=DM.GrpCoaTblTypeVal.AsInteger;
					wxIsDebit:=sxIsDebit(wxTypeVal);
				end;
			
				// If Section III - School Annual Report is being started (that is, section 2 is done) then
					// Clear net and sum of net fields
				if ((wxSectionNumber = 32) and (wxSectionState)) then
				begin
					wxNet:=0;
					wxSumOfNets:=0;
					wxNetBudgetYr2:=0;
					wxSONBudgetYr2:=0;
					wxSectionState:=false;
				end;
					
				// If Section IV Recap is being started then
					// process and print Section I - Errors
					// reset k1 and k2
					// write the Save Total Records to the Chart table
					// Clear net and sub of net fields
				if ((wxSectionNumber = 4) and (wxSectionState)) then
				begin
					wxSaveK1:=k1;
					sxSectionI;		// do section I - Errors
					k1:=wxSaveK1;
					sxWriteStToCoa;
					wxNet:=0;					
					wxSumOfNets:=0;
					wxNetBudgetYr2:=0;
					wxSONBudgetYr2:=0;
					wxSectionState:=false;
				end;
					
				// if Print Section (may be a heading for any section) then
					//	Write Report record
					//	Write "blank" sub record
					//	Set New Page After = the value of the BlankPage field from the COA record
				// endif
			//	endif
				if sxPrintSectionFlag then
				begin
					wxRptTbl.Append;
					wxRptTbl.FieldByName('wxRptK1').AsInteger:=k1;
					wxRptTbl.FieldByName('wxRptK2').AsInteger:=k2;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=0;
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=0;							// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptSrc').AsInteger:=DM.GrpCoaTblGrpSource.AsInteger; 			// Source spec number
					wxRptTbl.FieldByName('wxRptSrcDesc').AsString:=sxGetSrcDesc(DM.GrpCoaTblGrpSource); // Source spec description
					wxRptTbl.FieldByName('wxRptActNbr').AsString:=DM.GrpCoaTblNumber.AsString;	// Account#: this field is not used in the annual report group list
					wxRptTbl.FieldByName('wxRptAltAct').AsString:=DM.GrpCoaTblAlternateNumber.AsString;		// Alternate number (Diocesan account)
					wxRptTbl.FieldByName('wxRptActDesc').AsString:=DM.GrpCoaTblName.AsString;				// account description
					wxRptTbl.FieldByName('wxRptTotalLevel').AsInteger:=DM.GrpCoaTblTotalLevel.AsInteger;	// Total Level
					wxRptTbl.FieldByName('wxRptBlankLines').AsInteger:=DM.GrpCoaTblBlankLines.AsInteger;	// blank lines after
					wxRptTbl.FieldByName('wxRptNewPage').AsBoolean:=DM.GrpCoaTblBlankPage.AsBoolean;			// New Page After
					wxRptTbl.FieldByName('wxRptSection').AsInteger:=wxSectionNumber;				// revised: 5/27/2014 
					wxRptTbl.Post;
					sxWriteBlankSub(k1, k2, false);	// Visible parm is false for headings
					wxNewPageAfter:=DM.GrpCoaTblBlankPage.AsBoolean;
				end;	// end if Print Annual Report		
			end;	// end if heading

			// if Detail then
				//	Get Actual and Budget balances for Alternate Account Number from the COA table wxCoaTbl
						// the sxGetBalance() routine will write records to the sub-report table and delete records from the wxCoaTbl table
				// if Print Annual Report Then
					//	Write Report record
					//	Set New Page After = the value of the BlankPage field from the COA record
				// endif 
				// Update TotalLevel Table
			// endif
			if (DM.GrpCoaTblGrpSource.AsInteger = 13) then
			begin
// revised: 5/27/2014:
			//	wxAltBalance:=sxGetBalance(DM.GrpCoaTblAlternateNumber, k1, k2);
				wxResult := sxGetBalance(DM.GrpCoaTblAlternateNumber, k1, k2);	// the function will return the global vars wxAltBalTotal and wxBudYr2Total
				wxAltBalance:=wxAltBalTotal;
				wxBudgetYr2:=wxBudYr2Total;
// end revised 5/27/2014
				
				if sxPrintSectionFlag then
				begin
					wxRptTbl.Append;
					wxRptTbl.FieldByName('wxRptK1').AsInteger:=k1;
					wxRptTbl.FieldByName('wxRptK2').AsInteger:=k2;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=wxAltBalance;
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=wxBudgetYr2;			// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptSrc').AsInteger:=DM.GrpCoaTblGrpSource.AsInteger; 			// Source spec number
					wxRptTbl.FieldByName('wxRptSrcDesc').AsString:=sxGetSrcDesc(DM.GrpCoaTblGrpSource); // Source spec description
					wxRptTbl.FieldByName('wxRptActNbr').AsString:=DM.GrpCoaTblNumber.AsString;	// Account#; this field is not used in the annual report group list
					wxRptTbl.FieldByName('wxRptAltAct').AsString:=DM.GrpCoaTblAlternateNumber.AsString;		// Alternate number (Diocesan account)
					wxRptTbl.FieldByName('wxRptActDesc').AsString:=DM.GrpCoaTblName.AsString;				// account description
					wxRptTbl.FieldByName('wxRptTotalLevel').AsInteger:=DM.GrpCoaTblTotalLevel.AsInteger;	// Total Level
					wxRptTbl.FieldByName('wxRptBlankLines').AsInteger:=DM.GrpCoaTblBlankLines.AsInteger;	// blank lines after
					wxRptTbl.FieldByName('wxRptNewPage').AsBoolean:=DM.GrpCoaTblBlankPage.AsBoolean;			// New Page
					wxRptTbl.FieldByName('wxRptSection').AsInteger:=wxSectionNumber;; 		// revised: 5/27/2014
					wxRptTbl.Post;
					wxNewPageAfter:=DM.GrpCoaTblBlankPage.AsBoolean;
				end;	// end if print annual report
				sxUpdateTLevel(DM.GrpCoaTblTotalLevel.AsInteger, wxAltBalance, wxBudgetYr2);	// this writes the sub report total record
			end;	// end if detail

			// if Total then
				// Get actual and budget balances for total level
				//	If Alternate# specified then
					// Update the Save Total Table
				//	endif
				// if Print Annual Report then
					//	Write Report record
					//	Write "blank" sub record
				// endif
			if (DM.GrpCoaTblGrpSource.AsInteger = 5) then
			begin
				// revised: 5/27/2014:
					//	wxAltBalance:=sxGetTLevel(DM.GrpCoaTblTotalLevel.AsInteger);
					wxResult:=sxGetTLevel(DM.GrpCoaTblTotalLevel.AsInteger);
					wxAltBalance:=wxAltBalTotal;
					wxBudgetYr2:=wxBudYr2Total;
				// end revised 5/27/2014
				
				if ((DM.GrpCoaTblAlternateNumber.AsString <> '') and (DM.GrpCoaTblAlternateNumber.AsString <> '000') and (wxSectionNumber >= 31) and (wxSectionNumber <=33)) then
					sxUpdateSaveTotal(DM.GrpCoaTblAlternateNumber.AsString, wxTypeVal, DM.GrpCoaTblName.AsString, wxAltBalance, wxBudgetYr2);	// revised: 5/27/2014:
				
				if sxPrintSectionFlag then
				begin
					wxRptTbl.Append;
					wxRptTbl.FieldByName('wxRptK1').AsInteger:=k1;
					wxRptTbl.FieldByName('wxRptK2').AsInteger:=k2;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=0;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=wxAltBalance;
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=0;					// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=wxBudgetYr2;			// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptSrc').AsInteger:=DM.GrpCoaTblGrpSource.AsInteger; 			// Source spec number
					wxRptTbl.FieldByName('wxRptSrcDesc').AsString:=sxGetSrcDesc(DM.GrpCoaTblGrpSource); // Source spec description
					wxRptTbl.FieldByName('wxRptActNbr').AsString:=DM.GrpCoaTblNumber.AsString;	// Account#: this field is not used in the annual report group list
					wxRptTbl.FieldByName('wxRptAltAct').AsString:=DM.GrpCoaTblAlternateNumber.AsString;		// Alternate number (Diocesan account)
					wxRptTbl.FieldByName('wxRptActDesc').AsString:=DM.GrpCoaTblName.AsString;				// account description
					wxRptTbl.FieldByName('wxRptTotalLevel').AsInteger:=DM.GrpCoaTblTotalLevel.AsInteger;	// Total Level
					wxRptTbl.FieldByName('wxRptBlankLines').AsInteger:=DM.GrpCoaTblBlankLines.AsInteger;	// blank lines after
					wxRptTbl.FieldByName('wxRptNewPage').AsBoolean:=DM.GrpCoaTblBlankPage.AsBoolean;			// New Page after
					wxRptTbl.FieldByName('wxRptSection').AsInteger:=wxSectionNumber;; 		// revised: 5/27/2014
					wxRptTbl.Post;
					sxWriteBlankSub(k1, k2, false);	// sub report Visible flag is false for totals
					wxNewPageAfter:=DM.GrpCoaTblBlankPage.AsBoolean;
				end;	// end if print annual report

			end;	// end if total

			// if Net then
				// if Print Annual Report then
					//	Write Report record
					//	Write "blank" sub record
				// endif
			if (DM.GrpCoaTblGrpSource.AsInteger = 6) then
			begin
				wxAltBalance:=wxNet;
				wxNet:=0;
				wxBudgetYr2:=wxNetBudgetYr2;	// revised: 5/27/2014:
				wxNetBudgetYr2:=0;				// revised: 5/27/2014:
				
				if sxPrintSectionFlag then
				begin
					wxRptTbl.Append;
					wxRptTbl.FieldByName('wxRptK1').AsInteger:=k1;
					wxRptTbl.FieldByName('wxRptK2').AsInteger:=k2;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=0;
					wxRptTbl.FieldByName('wxRptAltBalance').AsCurrency:=wxAltBalance;
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=0;			// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptBudgetYr2').AsCurrency:=wxBudgetYr2;	// revised: 5/27/2014:
					wxRptTbl.FieldByName('wxRptSrc').AsInteger:=DM.GrpCoaTblGrpSource.AsInteger; 			// Source spec number
					wxRptTbl.FieldByName('wxRptSrcDesc').AsString:=sxGetSrcDesc(DM.GrpCoaTblGrpSource); // Source spec description
					wxRptTbl.FieldByName('wxRptActNbr').AsString:=DM.GrpCoaTblNumber.AsString;	// Account#: this field is not used in the annual report group list
					wxRptTbl.FieldByName('wxRptAltAct').AsString:=DM.GrpCoaTblAlternateNumber.AsString;		// Alternate number (Diocesan account)
					wxRptTbl.FieldByName('wxRptActDesc').AsString:=DM.GrpCoaTblName.AsString;				// account description
					wxRptTbl.FieldByName('wxRptTotalLevel').AsInteger:=DM.GrpCoaTblTotalLevel.AsInteger;	// Total Level
					wxRptTbl.FieldByName('wxRptBlankLines').AsInteger:=DM.GrpCoaTblBlankLines.AsInteger;	// blank lines after
					wxRptTbl.FieldByName('wxRptNewPage').AsBoolean:=DM.GrpCoaTblBlankPage.AsBoolean;			// New Page after
					wxRptTbl.FieldByName('wxRptSection').AsInteger:=wxSectionNumber;; 		// revised: 5/27/2014
					wxRptTbl.Post;
					sxWriteBlankSub(k1, k2, false);	// sub report visible parm is false for nets
					wxNewPageAfter:=DM.GrpCoaTblBlankPage.AsBoolean;
				end;	// end if print annual report
			end;	// end if print net

			// if Blank Line then
				// if Print Annual Report then
					//	Write "blank" main record
					//	Write "blank" sub record
				// endif
			if (DM.GrpCoaTblGrpSource.AsInteger = 7) then
			begin
				if sxPrintSectionFlag then
				begin
					sxWriteBlankMain(k1, k2, 3, '');
					sxWriteBlankSub(k1, k2, false);	// sub report does not need to "print" to produce a blank line
					wxNewPageAfter:=DM.GrpCoaTblBlankPage.AsBoolean;
				end;	// end if print annual report
			end;	// end if print blank line

			// if new page after then increment the Section/Page Sequence
			if (wxNewPageAfter = true) then
				inc(k1);

// ************
//		end; 	// end if same group id
// ***********		
		next;
		
      end;	// end DoWhile Not EOF
    end;	// end Do with DM.GrpCoaTbl
	
//	wxMsg:= 'Group Records Loaded = ' + IntToStr(k2);
//	showMessage(wxMsg);

	if (k2=0) then	// no records read, write one "blank" in rpt and sub tables
	begin
				sxWriteBlankMain(k1, 1, 3, 'no records read');	
				sxWriteBlankSub(k1, k2, false);
				
	end; // endif k2=0	
				
end;	// end procedure AfterSelectionsBuilt

// ******************************************************************************************************
// ******************************************************************************************************		
Revised: 5/27/2014
procedure BeforeDestroyReport;
// write the screen fields to the report ini file

var
	IniFile:	TIniFile;
	
begin
	if wxIniFieldsRead then
	begin
		IniFile:=TIniFile.Create(trim(DMReport.MainRepName)+'.ini');
		try
			IniFile.WriteString('LastInfo','wxChurchNumber',wxChurchNumber.text);
			IniFile.WriteString('LastInfo','wxChurchName',wxChurchName.text);
			IniFile.WriteString('LastInfo','wxCityName',wxCityName.text);
			IniFile.WriteString('LastInfo','wxYourName',wxYourName.text);
		finally
			IniFile.Free;
			IniFile:=nil;
		end;
	end;

end;	// end BeforeDestroyReport

// ******************************************************************************************************
// ******************************************************************************************************		

procedure BeforePrintReport;
begin

end;

procedure AfterSelectReport;

begin
	sxSetParms;
end;
